// Binary to 7 segment LED Decoder
// oCif[^7ZOgLEDp̃f[^ɕϊ܂B
// enable0ɂƏB
// _ZOg1ŕ\Ă邪Aۂɂ0œ_̂ŏ̃t@CŔ]Ă܂B


`default_nettype none
`timescale 1ns / 1ps

module B27segDec(binary, enable, segdecout);
	input [3:0] binary;
	input enable;
    output [6:0] segdecout;
	
	wire [3:0] binary;
	wire enable;
	reg [6:0] segdecout;
	
	always @* begin
		if (enable)
			case (binary)
				4'h0 :
					segdecout = 7'b1111110;
				4'h1 :
					segdecout = 7'b0110000;
				4'h2 :
					segdecout = 7'b1101101;
				4'h3 :
					segdecout = 7'b1111001;
				4'h4 :
					segdecout = 7'b0110011;
				4'h5 :
					segdecout = 7'b1011011;
				4'h6 :
					segdecout = 7'b1011111;
				4'h7 :
					segdecout = 7'b1110000;
				4'h8 :
					segdecout = 7'b1111111;
				4'h9 :
					segdecout = 7'b1111011;
				4'hA :
					segdecout = 7'b1110111;
				4'hB :
					segdecout = 7'b0011111;
				4'hC :
					segdecout = 7'b1001110;
				4'hD :
					segdecout = 7'b0111101;
				default : // F
					segdecout = 7'b1000111;
			endcase
		else
			segdecout = 7'b1111111;
	end
endmodule
	