// 7 segment LED \W[
// Suzaku-Vp
// led_enable͂VZOLED̕\𐧌䂷B1 - \

`default_nettype none
`timescale 1ns / 1ps

module SSegDisp(clk, reset, dot, led_enable, binary2, binary1, binary0, seg, nsel);
	input clk, reset;
	input [2:0] dot;
	input [2:0] led_enable;
	input [3:0] binary2, binary1, binary0;
	output [7:0] seg;
	output [2:0] nsel;
	wire clk, reset;
	wire [2:0] dot;
	wire [2:0] led_enable;
	wire [3:0] binary2, binary1, binary0;
	reg [7:0] seg;
	wire [2:0] nsel;
	
	reg [1:0] ledno;
	wire disp_ena;
	reg [2:0] nsel_node;
	wire [6:0] decout;
	reg [3:0] binary;
	reg led_ena;
	
	parameter clk_frequency = 200000;
	
	// LEDIpJE^
	always @(posedge clk) begin
		if (reset)
			ledno <= 0;
		else
			if (disp_ena)
				if (ledno==2)
					ledno <= 0;
				else
					ledno <= ledno + 1;
	end
	
	//\LEDI
	always @* begin
		case (ledno)
			2'b00 :
				nsel_node <= 3'b110;
			2'b01 :
				nsel_node <= 3'b101;
			default :
				nsel_node <= 3'b011;
		endcase
	end
	assign nsel = nsel_node;
	
	// LEDtbVg
	defparam FreqDiv_inst.clk_frequency = clk_frequency;
	FreqDiv FreqDiv_inst(
		.clk(clk),
		.reset(reset),
		.disp_ena(disp_ena)
	);
	
	// _Ci~bN_p}`vNT
	always @* begin
		case(ledno)
			2'b00 : begin
				binary <= binary0;
				led_ena <= led_enable[0];
				seg[7] <= dot[0];
			end
			2'b01 : begin
				binary <= binary1;
				led_ena <= led_enable[1];
				seg[7] <= dot[1];
			end
			2'b10 : begin
				binary <= binary2;
				led_ena <= led_enable[2];
				seg[7] <= dot[2];
			end
			default : begin
				binary <= {4{1'b1}};
				led_ena <= 1'b1;
				seg[7] <= 1'b1;
			end
		endcase
	end
	
	// 7ZOgLEDfR[_
	B27segDec B27segDec_inst (
		.binary(binary),
		.enable(led_ena),
		.segdecout(decout)
	);
	
	// 7ZOgLEDfR[_Suzaku-VLED̏ԂtȂ̂łȂ
	always @* begin : LED_SEG_LOOP
		integer i;
		
		for (i=0; i<7; i=i+1)
			seg[i] <= decout[6-i];
	end
endmodule
