// SuzakuV_DDR2_test.v
// Suzaku-VDDR2 SDRAMRg[eXgB
// SW1Œlݒ肷7ZOLED̈ʒuύXASW2ŒlDDR2 SDRAMփCgASW3DDR2 SDRAMkl[h
// l̐ݒ̓[^[GR_[gp

`default_nettype none
`timescale 1ns / 1ps

module SuzakuV_DDR2_test(SYS_CLK, SYS_RST, nSW, nCODE, SEG, nSEL, ddr2_clk, ddr2_clkb, ddr2_cke, ddr2_dqs, ddr2_dqs_n, ddr2_dq, ddr2_csb, ddr2_rasb, ddr2_casb, ddr2_web, ddr2_dm, ddr2_ba, ddr2_address, ddr2_odt, dummy_out);
	`include "./ddr2_cont_parameters.vh"
	
	input SYS_CLK, SYS_RST;
	input [2:0] nSW;
	input [3:0] nCODE;
	output [7:0] SEG;
	output [2:0] nSEL;
	output [QUANTITY_OF_CLK_OUTPUT-1 : 0] ddr2_clk;
	output [QUANTITY_OF_CLK_OUTPUT-1 : 0] ddr2_clkb;
	output ddr2_cke;
	output [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqs;
	output [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqs_n;
	inout [DDR2_DATA_WIDTH-1 : 0] ddr2_dq;
	output ddr2_csb;
	output ddr2_rasb;
	output ddr2_casb;
	output ddr2_web;
	output [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dm;
	output [1:0] ddr2_ba;
	output [DDR2_ADDRESS_WIDTH-1 : 0] ddr2_address;
	output ddr2_odt;
	output [31:14] dummy_out;
	
	wire SYS_CLK, SYS_RST;
	wire [2:0] nSW;
	wire [3:0] nCODE;
	wire [7:0] SEG;
	wire [2:0] nSEL;
	wire [3:0] nLE;
	wire [QUANTITY_OF_CLK_OUTPUT-1 : 0] ddr2_clk;
	wire [QUANTITY_OF_CLK_OUTPUT-1 : 0] ddr2_clkb;
	wire ddr2_cke;
	wire [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqs;
	wire [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqs_n;
	wire [DDR2_DATA_WIDTH-1 : 0] ddr2_dq;
	wire ddr2_csb;
	wire ddr2_rasb;
	wire ddr2_casb;
	wire ddr2_web;
	wire [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dm;
	wire [1:0] ddr2_ba;
	wire [DDR2_ADDRESS_WIDTH-1 : 0] ddr2_address;
	wire ddr2_odt;
	reg [31:14] dummy_out;

	wire [INTERFACE_DATA_WIDTH-1 : 0] input_data;
	wire [INTERFACE_MASK_WIDTH-1 : 0] input_mask;
	wire read_write;
	wire [INTERFACE_DATA_WIDTH-1 : 0] output_data;
	wire [USER_INPUT_ADDRESS_WIDTH-1 : 0] input_address;
	reg addr_fifo_wren; // AhXpFIFȌ݃Cl[u
	reg wrdata_fifo_wren; // FIFȌ݃Cl[u
	wire addr_fifo_full;
	wire wrdata_fifo_full;
	wire rddata_valid; // ǂݏof[^L
	wire initialize_end;
	reg [3:0] binary0, binary1, binary2;
	reg [2:0] sw_stat, sw_stat_1d, sw_stat_2d;
	reg [3:0] ledcnt;
	reg [2:0] seg_pos;
	wire sw_ena;
	wire clk;
	reg [3:0] CODE;
	reg [2:0] nSWL;
	wire reset;
	
	parameter clk_frequency = 200000; // _pA{ԗp
//	parameter clk_frequency = 100; // V~[VpA{ԗpł͑҂ĂƂ邢̂ŁBBB
	
	assign reset = SYS_RST; // SYS_RSTREAD{^ƂɃZbg
	
	SSegDisp SSegDisp_inst(
		.clk(clk),
		.reset(reset),
		.dot(seg_pos),
		.led_enable(3'b111), // LED\𐧌
		.binary2(binary2),
		.binary1(binary1),
		.binary0(binary0),
		.seg(SEG),
		.nsel(nSEL)
	);
	defparam SSegDisp_inst.clk_frequency = clk_frequency;
	
	always @(posedge clk) begin // nCODE𔽓]ăb`
		if (reset)
			CODE <= 0;
		else
			CODE <= ~nCODE;
	end
	
	SWDiv SWDiv_inst( // XCb``^Op
		.clk(clk),
		.reset(reset),
		.sw_ena(sw_ena)
	);
	defparam SWDiv_inst.clk_frequency = clk_frequency;
	
	// ŏɕe[uԂh߂nSWb`
	always @(posedge clk) begin
		nSWL <= nSW;
	end
	
	always @(posedge clk) begin // XCb``^O
		if (reset)
			sw_stat <= 0;
		else if (sw_ena) // `^OpCl[u
			sw_stat <= ~nSWL;
	end
	always @(posedge clk) begin // SW1NbNx̐M
		if (reset) begin
			sw_stat_1d <= 0;
			sw_stat_2d <= 0;
		end else begin
			sw_stat_1d <= sw_stat;
			sw_stat_2d <= sw_stat_1d;
		end
	end

	always @(posedge clk) begin // binary0, 1, 2̂ǂZbg邩seg_posŎ
		if (reset)
			seg_pos <= 3'b001;
		else if (sw_stat[0]==1'b1 && sw_stat_1d[0]==1'b0) // SW11̂ƂɈʒuړ
			case (seg_pos)
				3'b001 :
					seg_pos <= 3'b010;
				3'b010 :
					seg_pos <= 3'b100;
				3'b100 :
					seg_pos <= 3'b001;
				default :
					seg_pos <= 3'b001;
			endcase
	end
	
	always @(posedge clk) begin // binary0
		if (reset)
			binary0 <= 0;
		else if (sw_stat[0]==1'b1 && sw_stat_1d[0]==1'b0 && seg_pos[0]==1'b1) // SW01̂ƂɃGR[_[XCb`̒lZbg
			binary0 <= CODE;
		else if (rddata_valid) // Read
			binary0 <= output_data[3:0];
	end
	always @(posedge clk) begin // binary1
		if (reset)
			binary1 <= 0;
		else if (sw_stat[0]==1'b1 && sw_stat_1d[0]==1'b0 && seg_pos[1]==1'b1) // SW01̂ƂɃGR[_[XCb`̒lZbg
			binary1 <= CODE;
		else if (rddata_valid) // Read
			binary1 <= output_data[7:4];
	end
	always @(posedge clk) begin // binary2
		if (reset)
			binary2 <= 0;
		else if (sw_stat[0]==1'b1 && sw_stat_1d[0]==1'b0 && seg_pos[2]==1'b1) // SW01̂ƂɃGR[_[XCb`̒lZbg
			binary2 <= CODE;
		else if (rddata_valid) // Read
			binary2 <= output_data[11:8];
	end	
	
	always @(posedge clk) begin
		if (reset)
			dummy_out <= 0;
		else
			if (rddata_valid)
				dummy_out <= output_data[31:14];
	end
	
	// Write, SW3ƂɃCg(2NbNԁj
	// Read, SW2ƂɃ[h
	always @(posedge clk) begin
		if (reset)
			wrdata_fifo_wren <= 1'b0;
		else if (sw_stat[2]==1'b1 && sw_stat_1d[2]==1'b0)
			wrdata_fifo_wren <= 1'b1;
		else if (sw_stat_1d[2]==1'b1 && sw_stat_2d[2]==1'b0)
			wrdata_fifo_wren <= 1'b1;
		else
			wrdata_fifo_wren <= 1'b0;
	end
	assign read_write = ~wrdata_fifo_wren;
	assign input_address = 0;
	assign input_mask = 0;
	assign input_data = (sw_stat_1d[2]==1'b1 && sw_stat_2d[2]==1'b0) ? {~binary1, ~binary0, ~binary2, ~binary1, ~binary0, ~binary2, ~binary1, ~binary0} : {binary1, binary0, binary2, binary1, binary0, binary2, binary1, binary0}; // wrdata_fifo_wren1NbNxĂ̂ŁA
	
	always @(posedge clk) begin // addr_fifo_wren
		if (reset)
			addr_fifo_wren <= 1'b0;
		else if (sw_stat[2]==1'b1 && sw_stat_1d[2]==1'b0) // Write
			addr_fifo_wren <= 1'b1;
		else if (sw_stat[1]==1'b1 && sw_stat_1d[1]==1'b0) // Read
			addr_fifo_wren <= 1'b1;
		else
			addr_fifo_wren <= 1'b0;
	end
	
	ddr2_sdram_cont ddr2_sdram_cont_inst (
		.clk_in(SYS_CLK),
		.clk_out(clk),
		.reset(reset),
		.input_data(input_data),
		.input_mask(input_mask),
		.read_write(read_write),
		.output_data(output_data),
		.input_address(input_address),
		.addr_fifo_wren(addr_fifo_wren),
		.wrdata_fifo_wren(wrdata_fifo_wren),
		.addr_fifo_full(addr_fifo_full),
		.wrdata_fifo_full(wrdata_fifo_full),
		.rddata_valid(rddata_valid),
		.initialize_end(initialize_end),
		.ddr2_clk(ddr2_clk),
		.ddr2_clkb(ddr2_clkb),
		.ddr2_cke(ddr2_cke),
		.ddr2_dqs(ddr2_dqs),
		.ddr2_dqs_n(ddr2_dqs_n),
		.ddr2_dq(ddr2_dq),
		.ddr2_csb(ddr2_csb),
		.ddr2_rasb(ddr2_rasb),
		.ddr2_casb(ddr2_casb),
		.ddr2_web(ddr2_web),
		.ddr2_dm(ddr2_dm),
		.ddr2_ba(ddr2_ba),
		.ddr2_address(ddr2_address),
		.ddr2_odt(ddr2_odt)
	);
endmodule
