// DDR2 SDRAM Controller
// XAPP253ƔrăAhXFIFO{āA[hƃCg̃AhXFIFO1ɂB邱ƂɂāA[hƃCgEANZX̗D揇ʂ̖B
// DDR2ł4o[Xgœ삷Bwrdata_fifo2f[^̕łB̂wrdata_fifoɘA2f[^
// 
// 2006.12.14
// 2008.02.10 : IOBɓ_͈ԏɎĂ܂B
// 2008.05.05 : ǂ̓ADQ̓͒xωDDR2 SDRAM̃f[^[h͕ςɁAŏɎQƃp^[݁Ǎナ[hȂIDELAYύXȂœK_BIDELAY̍œK_ɃZbgB
// 2008/06/08 : DQxēNbNŃf[^[h@͂߂āADQSDQTv@ɉ߂

`default_nettype none
`timescale 1ns / 1ps

module ddr2_sdram_cont (clk_in, clk_out, reset, input_data, input_mask, read_write, output_data, input_address, addr_fifo_wren, wrdata_fifo_wren, addr_fifo_full, wrdata_fifo_full, rddata_valid, initialize_end, dcm_locked, ddr2_clk, ddr2_clkb, ddr2_cke, ddr2_dqs, ddr2_dqs_n, ddr2_dq, ddr2_csb, ddr2_rasb, ddr2_casb, ddr2_web, ddr2_dm, ddr2_ba, ddr2_address, ddr2_odt);
	`include "./ddr2_cont_parameters.vh"
	
	input clk_in; // NbN
	output clk_out; // NbNo
	input reset;
	input [INTERFACE_DATA_WIDTH-1 : 0] input_data;
	input [INTERFACE_MASK_WIDTH-1 : 0] input_mask;
	input read_write;
	output [INTERFACE_DATA_WIDTH-1 : 0] output_data;
	input [USER_INPUT_ADDRESS_WIDTH-1 : 0] input_address;
	input addr_fifo_wren; // AhXpFIFȌ݃Cl[u
	input wrdata_fifo_wren; // FIFȌ݃Cl[u
	output addr_fifo_full;
	output wrdata_fifo_full;
	output rddata_valid; // ǂݏof[^L
	output initialize_end;
	output dcm_locked;
	output [QUANTITY_OF_CLK_OUTPUT-1 : 0] ddr2_clk;
	output [QUANTITY_OF_CLK_OUTPUT-1 : 0] ddr2_clkb;
	output ddr2_cke;
	inout [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqs;
	output [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqs_n;
	inout [DDR2_DATA_WIDTH-1 : 0] ddr2_dq;
	output ddr2_csb;
	output ddr2_rasb;
	output ddr2_casb;
	output ddr2_web;
	output [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dm;
	output [1:0] ddr2_ba;
	output [DDR2_ADDRESS_WIDTH-1 : 0] ddr2_address;
	output ddr2_odt;
	
	wire clk_in; // NbN
	wire clk_out; // NbNo
	wire reset;
	wire [INTERFACE_DATA_WIDTH-1 : 0] input_data;
	wire [INTERFACE_MASK_WIDTH-1 : 0] input_mask;
	wire read_write;
	wire [INTERFACE_DATA_WIDTH-1 : 0] output_data;
	wire [USER_INPUT_ADDRESS_WIDTH-1 : 0] input_address;
	wire addr_fifo_wren; // AhXpFIFȌ݃Cl[u
	wire wrdata_fifo_wren; // FIFȌ݃Cl[u
	wire addr_fifo_full;
	wire wrdata_fifo_full;
	wire rddata_valid; // ǂݏof[^L
	wire initialize_end;
	wire dcm_locked;
	wire [QUANTITY_OF_CLK_OUTPUT-1 : 0] ddr2_clk;
	wire [QUANTITY_OF_CLK_OUTPUT-1 : 0] ddr2_clkb;
	wire ddr2_cke;
	wire [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqs;
	reg [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqs_n;
	wire [DDR2_DATA_WIDTH-1 : 0] ddr2_dq;
	wire ddr2_csb;
	wire ddr2_rasb;
	wire ddr2_casb;
	wire ddr2_web;
	wire [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dm;
	wire [1:0] ddr2_ba;
	wire [DDR2_ADDRESS_WIDTH-1 : 0] ddr2_address;
	wire ddr2_odt;
	
	wire clk, clk90, clkx, clk270, clk1_16, dcm_lock;
	wire [USER_INPUT_ADDRESS_WIDTH-1 : 0] address, next_address;
	wire read_writex, next_read_writex;
	wire addr_fifo_empty, addr_fifo_almost_empty, addr_fifo_rden;
	wire wrdata_fifo_empty, wrdata_fifo_almost_empty, wrdata_fifo_rden;
	wire dqs_enable, dqs_reset, write_timing, read_timing, burst_read;
	wire [INTERFACE_DATA_WIDTH-1 : 0] wrdata_fifo_data;
	wire [INTERFACE_MASK_WIDTH-1 : 0] wrdata_fifo_mask;
	wire wrdata_fifo_almost_full;
	wire rddata_fifo_rden;
	wire rddata_fifo_empty ,rddata_fifo_almost_empty;
	wire [INTERFACE_DATA_WIDTH-1 : 0] rddata_fifo_data;
	wire rddata_fifo_wren, rddata_fifo_full, rddata_fifo_almost_full;
	wire ie;
	reg iel;
	wire [DDR2_DATA_WIDTH-1 : 0] dq_rise_1d, dq_fall_1d;
	(* max_fanout="1" *) reg [DDR2_DQS_DM_WIDTH-1 : 0] dqs_tri_enable_3dx, dqs_tri_enable_d3dx;
	(* max_fanout="1" *) wire [DDR2_DQS_DM_WIDTH*8-1 : 0] dqs_enable_3d;
	wire [INTERFACE_DATA_WIDTH-1 : 0] wrdata_2d, wrdata_3d;
	wire [DDR2_DATA_WIDTH-1 : 0] out_tri;
	wire [INTERFACE_MASK_WIDTH-1 : 0] wrmask_3d, wrmask_2d;
	wire [DDR2_DATA_WIDTH-1 : 0] ddr2_dq_in, ddr2_dq_idelay;
	wire [DDR2_DATA_WIDTH-1 : 0] ddr2_out;
	wire [DDR2_DQS_DM_WIDTH-1 : 0] dqs_oq, dqs_tq;
	wire [DDR2_DQS_DM_WIDTH-1 : 0] dqsn_oq, dqsn_tq;
	
	wire pattern_write_state;
	wire read_data_is_right;
	wire rddata_is_right_timing;
	wire idelay_inc;
	wire idelay_ce;
	wire [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqsin_out, ddr2_dqsin_bufio, ddr2_dqsin;
	(* max_fanout="1" *) wire [4*DDR2_DATA_WIDTH-1 : 0] dq_oserdes_t_2d;
	(* max_fanout="1" *) wire [4*DDR2_DQS_DM_WIDTH-1 : 0] dqs_oserdes_d_1d, dqs_oserdes_t_1d;
	(* max_fanout="1" *) wire [4*DDR2_DQS_DM_WIDTH-1 : 0] dqsn_oserdes_d_1d, dqsn_oserdes_t_1d;
	wire clk100MHz;
	wire clk100_rising_edge;
	
	
	assign dcm_locked = dcm_lock;
	
	dcm_module dcm_module_inst (
		.sysclk(clk_in),
		.reset(reset),
		.ddr2_clk(ddr2_clk),
		.ddr2_clkb(ddr2_clkb),
		.clk(clk),
		.clk90(clk90),
		.clkx(clkx),
		.clk270(clk270),
		.clk1_16(clk1_16),
		.clk100MHz(clk100MHz),
		.clk100_rising_edge(clk100_rising_edge),
		.dcm_lock(dcm_lock)
	);
	
	controller controller_inst (
		.clk(clk),
		.clkx(clkx),
		.clk1_16(clk1_16),
		.reset(reset),
		.dcm_lock(dcm_lock),
		.address(address),
		.read_writex(read_writex),
		.next_address(next_address),
		.next_read_writex(next_read_writex),
		.addr_fifo_rden(addr_fifo_rden),
		.addr_fifo_empty(addr_fifo_empty),
		.addr_fifo_almost_empty(addr_fifo_almost_empty),
		.wrdata_fifo_empty(wrdata_fifo_empty),
		.wrdata_fifo_almost_empty(wrdata_fifo_almost_empty),
		.wrdata_fifo_rden(wrdata_fifo_rden),
		.ddr2_rasb(ddr2_rasb),
		.ddr2_casb(ddr2_casb),
		.ddr2_web(ddr2_web),
		.ddr2_ba(ddr2_ba),
		.ddr2_address(ddr2_address),
		.ddr2_cke(ddr2_cke),
		.ddr2_csb(ddr2_csb),
		.dqs_enable(dqs_enable),
		.dqs_reset(dqs_reset),
		.write_timing(write_timing),
		.read_timing(read_timing),
		.burst_read(burst_read),
		.initialize_end(ie),
		.clk100_rising_edge(clk100_rising_edge),
		.pattern_write_state(pattern_write_state),
		.read_data_is_right(read_data_is_right),
		.rddata_is_right_timing(rddata_is_right_timing),
		.idelay_inc(idelay_inc),
		.idelay_ce(idelay_ce)
	);
	always @(posedge clk) begin
		if (reset==1'b1)
			iel <= 1'b0;
		else
			iel <= ie;
	end
	assign initialize_end = iel;
	
	read_data_module read_data_module_inst (
		.reset(reset),
		.clk(clk),
		.clkx(clkx),
		.read_timing(read_timing),
		.burst_read(burst_read),
		.rddata_fifo_data(rddata_fifo_data),
		.rddata_fifo_wren(rddata_fifo_wren),
		.rddata_fifo_full(rddata_fifo_full),
		.rddata_fifo_almost_full(rddata_fifo_almost_full),
		.dq_rise_1d(dq_rise_1d),
		.dq_fall_1d(dq_fall_1d),
		.read_data_is_right(read_data_is_right),
		.rddata_is_right_timing(rddata_is_right_timing)
	);
	
	write_data_module write_data_module_inst (
		.reset(reset),
		.clk(clk),
		.clk90(clk90),
		.clkx(clkx),
		.clk270(clk270),
		.wrdata_fifo_data(wrdata_fifo_data),
		.wrdata_fifo_mask(wrdata_fifo_mask),
		.dqs_enable(dqs_enable),
		.dqs_reset(dqs_reset),
		.clk100_rising_edge(clk100_rising_edge),
		.pattern_write_state(pattern_write_state),
		.wrdata_2d(wrdata_2d),
		.wrdata_3d(wrdata_3d),
		.wrmask_2d(wrmask_2d),
		.wrmask_3d(wrmask_3d),
		.dq_oserdes_t_2d(dq_oserdes_t_2d),
		.dqs_oserdes_d_1d(dqs_oserdes_d_1d),
		.dqs_oserdes_t_1d(dqs_oserdes_t_1d),
		.dqsn_oserdes_d_1d(dqsn_oserdes_d_1d),
		.dqsn_oserdes_t_1d(dqsn_oserdes_t_1d)
	);
	
	addr_fifo addr_fifo_inst (
		.clk(clk),
		.reset(reset),
		.din(input_address),
		.read_write(read_write),
		.wr_en(addr_fifo_wren),
		.rd_en(addr_fifo_rden),
		.dout(address),
		.rw_out(read_writex),
		.full(addr_fifo_full),
		.empty(addr_fifo_empty),
		.next_dout(next_address),
		.next_rw_out(next_read_writex),
		.almost_empty(addr_fifo_almost_empty),
		.almost_full()
	);
	
	wrdata_fifo wrdata_fifo_inst (
		.clk(clk),
		.reset(reset),
		.din(input_data),
		.maskin(input_mask),
		.rd_en(wrdata_fifo_rden),
		.wr_en(wrdata_fifo_wren),
		.full(wrdata_fifo_full),
		.almost_full(wrdata_fifo_almost_full),
		.empty(wrdata_fifo_empty),
		.almost_empty(wrdata_fifo_almost_empty),
		.dout(wrdata_fifo_data),
		.maskout(wrdata_fifo_mask)
	);
	
	rddata_fifo rddata_fifo_inst (
		.clk(clk),
		.reset(reset),
		.din(rddata_fifo_data),
		.rd_en(rddata_fifo_rden),
		.wr_en(rddata_fifo_wren),
		.full(rddata_fifo_full),
		.almost_full(rddata_fifo_almost_full),
		.empty(rddata_fifo_empty),
		.almost_empty(rddata_fifo_almost_empty),
		.dout(output_data)
	);
	assign rddata_fifo_rden = (rddata_fifo_empty==1'b0) ? 1'b1 : 1'b0; // emptyłȂ́A[hf[^ǂݏo
	assign rddata_valid = rddata_fifo_rden;
	assign clk_out = clk;
	assign ddr2_odt = 1'b0; // ODT̓fBXG[u
	// assign ddr2_odt = 1'b1; // ODT̓Cl[u

	// ddr2_dqIOBv~eBuŃCX^VG[V
	generate
	genvar i;
		for (i=DDR2_DATA_WIDTH-1; i>=0; i=i-1) begin: WRDATA_INOUT
			OSERDES # (
				.DATA_RATE_OQ("DDR"),
				.DATA_RATE_TQ("DDR"),
				.DATA_WIDTH(4),
				.INIT_OQ(1'b0),
				.INIT_TQ(1'b1),
				.SERDES_MODE("MASTER"),
				.SRVAL_OQ(1'b0),
				.SRVAL_TQ(1'b1),
				.TRISTATE_WIDTH(4)
			) WRDATA_DDR2_OUT (
				.OQ(ddr2_out[i]),
				.SHIFTOUT1(),
				.SHIFTOUT2(),
				.TQ(out_tri[i]),
				.CLK(clk270),
				.CLKDIV(~clk100MHz),
				.D1(wrdata_3d[i]),
				.D2(wrdata_3d[i+INTERFACE_DATA_WIDTH/2]),
				.D3(wrdata_2d[i]),
				.D4(wrdata_2d[i+INTERFACE_DATA_WIDTH/2]),
				.D5(),
				.D6(),
				.OCE(1'b1),
				.REV(1'b0),
				.SHIFTIN1(1'b0),
				.SHIFTIN2(1'b0),
				.SR(reset),
				.T1(dq_oserdes_t_2d[i*4]),
				.T2(dq_oserdes_t_2d[i*4+1]),
				.T3(dq_oserdes_t_2d[i*4+2]),
				.T4(dq_oserdes_t_2d[i*4+3]),
				.TCE(1'b1)
			);
						
		 	ISERDES #(
				.BITSLIP_ENABLE("FALSE"),
				.DATA_RATE("DDR"),
				.DATA_WIDTH(4),
				.INTERFACE_TYPE("MEMORY"),
				.IOBDELAY("IFD"),
				.IOBDELAY_TYPE("FIXED"),
				.IOBDELAY_VALUE(0),
				.NUM_CE(1),
				.SERDES_MODE("MASTER")
			) DDR2_DQ_INPUT (
		 		.O(),
		 		.Q1(dq_fall_1d[i]), 
		 		.Q2(dq_rise_1d[i]), 
		 		.Q3(), 
		 		.Q4(), 
		 		.Q5(), 
		 		.Q6(), 
		 		.SHIFTOUT1(), 
		 		.SHIFTOUT2(),
		 		.BITSLIP(1'b0),
		 		.CE1(1'b1), 
		 		.CE2(1'b1),
		 		.CLK(ddr2_dqsin_bufio[i/8]),
		 		.CLKDIV(clk270),
		 		.D(ddr2_dq_in[i]),
		 		.DLYCE(1'b0),
		 		.DLYINC(1'b0),
		 		.DLYRST(1'b0),
		 		.OCLK(clk270), 
		 		.REV(1'b0),  
		 		.SHIFTIN1(1'b0), 
		 		.SHIFTIN2(1'b0),
		 		.SR(reset)
		 	 );
			 
			IOBUF DDD2_DQ_BUF (
				.O(ddr2_dq_in[i]),
				.IO(ddr2_dq[i]),
				.I(ddr2_out[i]),
				.T(out_tri[i])
			);
		end
	endgenerate
	
	IDELAYCTRL WRDATA_IDELAYCTRL (
		.RDY(),
		.REFCLK(clk),
		.RST(reset)
	);
	
	// Instantiate Mask DDR registers
	generate
	genvar m;
		for (m=DDR2_DQS_DM_WIDTH-1; m>=0; m=m-1) begin: WRDATA_MASK
			OSERDES # (
				.DATA_RATE_OQ("DDR"),
				.DATA_RATE_TQ("DDR"),
				.DATA_WIDTH(4),
				.INIT_OQ(1'b0),
				.INIT_TQ(1'b1),
				.SERDES_MODE("MASTER"),
				.SRVAL_OQ(1'b0),
				.SRVAL_TQ(1'b1),
				.TRISTATE_WIDTH(4)
			) WRMASK_DDR2_OUT (
				.OQ(ddr2_dm[m]),
				.SHIFTOUT1(),
				.SHIFTOUT2(),
				.TQ(),
				.CLK(clk270),
				.CLKDIV(~clk100MHz),
				.D1(wrmask_3d[m]),
				.D2(wrmask_3d[m+INTERFACE_MASK_WIDTH/2]),
				.D3(wrmask_2d[m]),
				.D4(wrmask_2d[m+INTERFACE_MASK_WIDTH/2]),
				.D5(),
				.D6(),
				.OCE(1'b1),
				.REV(1'b0),
				.SHIFTIN1(1'b0),
				.SHIFTIN2(1'b0),
				.SR(reset),
				.T1(1'b0),
				.T2(1'b0),
				.T3(1'b0),
				.T4(1'b0),
				.TCE(1'b1)
			);
		end
	endgenerate
	
	// Instantiate DQS DDR registers
	generate
	genvar n;
		for (n=DDR2_DQS_DM_WIDTH-1; n>=0; n=n-1) begin: WRDATA_DQS
			OSERDES # (
				.DATA_RATE_OQ("DDR"),
				.DATA_RATE_TQ("DDR"),
				.DATA_WIDTH(4),
				.INIT_OQ(1'b0),
				.INIT_TQ(1'b1),
				.SERDES_MODE("MASTER"),
				.SRVAL_OQ(1'b0),
				.SRVAL_TQ(1'b1),
				.TRISTATE_WIDTH(4)
			) WRDQS_DDR2_OUT (
				.OQ(dqs_oq[n]),
				.SHIFTOUT1(),
				.SHIFTOUT2(),
				.TQ(dqs_tq[n]),
				.CLK(clk),
				.CLKDIV(~clk100MHz),
				.D1(dqs_oserdes_d_1d[n*4]),
				.D2(dqs_oserdes_d_1d[n*4+1]),
				.D3(dqs_oserdes_d_1d[n*4+2]),
				.D4(dqs_oserdes_d_1d[n*4+3]),
				.D5(),
				.D6(),
				.OCE(1'b1),
				.REV(1'b0),
				.SHIFTIN1(1'b0),
				.SHIFTIN2(1'b0),
				// .SR(dqs_reset_3d[n]),
				.SR(reset),
				.T1(dqs_oserdes_t_1d[n*4]),
				.T2(dqs_oserdes_t_1d[n*4+1]),
				.T3(dqs_oserdes_t_1d[n*4+2]),
				.T4(dqs_oserdes_t_1d[n*4+3]),
				.TCE(1'b1)
			);
			
		 	ISERDES #(
				.BITSLIP_ENABLE("TRUE"),
				.DATA_RATE("DDR"),
				.DATA_WIDTH(4),
				.INTERFACE_TYPE("NETWORKING"),
				.IOBDELAY("BOTH"),
				.IOBDELAY_TYPE("FIXED"),
				.IOBDELAY_VALUE(17),
				// .IOBDELAY_VALUE(17),
				.NUM_CE(1),
				.SERDES_MODE("MASTER")
			) DQS_DDR2_IN (
		 		.O(ddr2_dqsin_out[n]),
		 		.Q1(), 
		 		.Q2(), 
		 		.Q3(), 
		 		.Q4(), 
		 		.Q5(), 
		 		.Q6(), 
		 		.SHIFTOUT1(), 
		 		.SHIFTOUT2(),
		 		.BITSLIP(1'b0),
		 		.CE1(1'b1), 
		 		.CE2(1'b1),
		 		.CLK(1'b0),
		 		.CLKDIV(clk),
		 		.D(ddr2_dqsin[n]),
		 		.DLYCE(1'b0),
		 		.DLYINC(1'b0),
		 		.DLYRST(1'b0),
		 		.OCLK(clk), 
		 		.REV(1'b0),  
		 		.SHIFTIN1(1'b0), 
		 		.SHIFTIN2(1'b0),
		 		.SR(reset)
		 	 );
			 
			 BUFIO DQS_DDR2_IN_BUFIO (
				.I(ddr2_dqsin_out[n]),
				.O(ddr2_dqsin_bufio[n])
			);
			
			IOBUF DDD2_DQS_BUF (
				.O(ddr2_dqsin[n]),
				.IO(ddr2_dqs[n]),
				.I(dqs_oq[n]),
				.T(dqs_tq[n])
			);
		end
	endgenerate
	
	
	// Instantiate DQS_N DDR registers(DQSƋtɐj
	generate
	genvar j;
		for (j=DDR2_DQS_DM_WIDTH-1; j>=0; j=j-1) begin: WRDATA_DQSN
			OSERDES # (
				.DATA_RATE_OQ("DDR"),
				.DATA_RATE_TQ("DDR"),
				.DATA_WIDTH(4),
				.INIT_OQ(1'b0),
				.INIT_TQ(1'b1),
				.SERDES_MODE("MASTER"),
				.SRVAL_OQ(1'b0),
				.SRVAL_TQ(1'b1),
				.TRISTATE_WIDTH(4)
			) WRDQSN_DDR2_OUT (
				.OQ(dqsn_oq[j]),
				.SHIFTOUT1(),
				.SHIFTOUT2(),
				.TQ(dqsn_tq[j]),
				.CLK(clk),
				.CLKDIV(~clk100MHz),
				.D1(dqsn_oserdes_d_1d[j*4]),
				.D2(dqsn_oserdes_d_1d[j*4+1]),
				.D3(dqsn_oserdes_d_1d[j*4+2]),
				.D4(dqsn_oserdes_d_1d[j*4+3]),
				.D5(),
				.D6(),
				.OCE(1'b1),
				.REV(1'b0),
				.SHIFTIN1(1'b0),
				.SHIFTIN2(1'b0),
				.SR(reset),
				.T1(dqsn_oserdes_t_1d[j*4]),
				.T2(dqsn_oserdes_t_1d[j*4+1]),
				.T3(dqsn_oserdes_t_1d[j*4+2]),
				.T4(dqsn_oserdes_t_1d[j*4+3]),
				.TCE(1'b1)
			);
			
			always @* begin
				if (dqsn_tq[j])
					ddr2_dqs_n[j] <= 1'bz;
				else
					ddr2_dqs_n[j] <= dqsn_oq[j];
			end
			// OBUFT DDR2_DQSN_BUF(
				// .O(ddr2_dqs_n[j]),
				// .I(dqsn_oq[j]),
				// .T(dqsn_tq[j])
			// );
		end
	endgenerate

endmodule
