// Read Data Module
// ReadDDR SDRAM̃f[^󂯂
// DQzxAZbgAbvԂ𑍌vĎ3/4炷Bclknot clkŃf[^TvłB
// DDR24o[Xgpread_timing1NbNL΂

// 2008/04/15 Ver. 1.1 : 炷Ԃ1/43/4ɕύX

`default_nettype none
`timescale 1ns / 1ps

module read_data_module(reset, clk, clkx, read_timing, burst_read, rddata_fifo_data, rddata_fifo_wren, rddata_fifo_full, rddata_fifo_almost_full, dq_rise_1d, dq_fall_1d, read_data_is_right, rddata_is_right_timing);
	`include "./ddr2_cont_parameters.vh"

	input reset;
	input clk;
	input clkx;
	input read_timing;
	input burst_read;
	output [INTERFACE_DATA_WIDTH-1 : 0] rddata_fifo_data;
	output rddata_fifo_wren;
	input rddata_fifo_full;
	input rddata_fifo_almost_full;
	
	input [DDR2_DATA_WIDTH-1 : 0] dq_rise_1d, dq_fall_1d;
	output read_data_is_right;
	output rddata_is_right_timing;
	
	wire reset;
	wire clk;
	wire clkx;
	wire read_timing;
	wire burst_read;
	reg [INTERFACE_DATA_WIDTH-1 : 0] rddata_fifo_data, rddata_fifo_data_node;
	wire [INTERFACE_DATA_WIDTH-1 : 0] rddata_fifo_data_1b;
	wire rddata_fifo_wren;
	wire rddata_fifo_full;
	wire rddata_fifo_almost_full;
	wire [DDR2_DATA_WIDTH-1 : 0] dq_rise_1d, dq_fall_1d;
	reg read_data_is_right, bread_data_is_right;
	
	reg rddata_fifo_wren_node0, rddata_fifo_wren_node1, rddata_fifo_wren_node2, rddata_fifo_wren_node3;
	reg read_timing_1d;
	reg rddata_is_right_timing;
	
	always @(posedge clkx) begin
		if (reset)
			read_timing_1d <= 1'b0;
		else
			read_timing_1d <= read_timing;
	end
	
	always @(posedge clkx) begin
		if (reset) begin
			rddata_fifo_wren_node0 <= 1'b0;
		end else begin
			rddata_fifo_wren_node0 <= read_timing;
		end
	end
	
	always @(posedge clk) begin // f[^clkxclkɏ悹
		if (reset) begin
			rddata_fifo_wren_node1 <= 1'b0;
			rddata_fifo_wren_node2 <= 1'b0;
			rddata_fifo_wren_node3 <= 1'b0;
		end else begin
			rddata_fifo_wren_node1 <= rddata_fifo_wren_node0;
			rddata_fifo_wren_node2 <= rddata_fifo_wren_node1;
			rddata_fifo_wren_node3 <= rddata_fifo_wren_node2;
		end
	end
			
			
	assign rddata_fifo_data_1b = {dq_fall_1d, dq_rise_1d}; // ŏɏoĂ(rise)O[h(gEGfBAj
	assign rddata_fifo_wren = rddata_fifo_wren_node3;
	
	always @(posedge clkx) begin // NbN悹
		if (reset)
			rddata_fifo_data <= 0;
		else
			rddata_fifo_data <= rddata_fifo_data_1b;
	end
	
	always @(posedge clk) begin // NbN悹
		if (reset)
			rddata_fifo_data_node <= 0;
		else
			rddata_fifo_data_node <= rddata_fifo_data;
	end	
	
	always @(posedge clk) begin // Ƀ[hEf[^INITIAL_PATTERNƍĂ邩ǂrif[^2NbNj
		if (reset) begin
			read_data_is_right <= 1'b0;
			bread_data_is_right <= 1'b0;
		end else begin
			if (bread_data_is_right && rddata_fifo_data_node=={INITIAL_PATTERN_1, INITIAL_PATTERN_2} && rddata_fifo_wren==1'b1)		
				read_data_is_right <= 1'b1; // 2ڂf[^
			else if (bread_data_is_right==1'b0 && rddata_fifo_data_node=={INITIAL_PATTERN_1, INITIAL_PATTERN_2} && rddata_fifo_wren==1'b1)
				bread_data_is_right <= 1'b1; // 1ڂ͐f[^
			else begin
				read_data_is_right <= 1'b0;
				bread_data_is_right <= 1'b0;
			end
		end
	end
	
	always @(posedge clk) begin // read_data_is_right̏o̓^C~Ow
		if (reset)
			rddata_is_right_timing <= 1'b0;
		else begin
			if (rddata_fifo_wren_node1 && rddata_fifo_wren_node2)
				rddata_is_right_timing <= 1'b1;
			else
				rddata_is_right_timing <= 1'b0;
		end
	end
			
endmodule

