// Write Data Module
// DQSDQADMo͂
// DQSclk90ɘAĕωB
// DQWRITsꂽclk(0xʑj̔NbNォCl[uɂB

// 2008/04/23 : Ver. 1.1 : pattern_write_state̎ɏp^[
// 2008/07/28 : Ver. 1.2 : OSERDESgp邽߂ɕύX

`default_nettype none
`timescale 1ns / 1ps

module write_data_module (
	reset,
	clk, clk90, clkx, clk270,
	wrdata_fifo_data,
	wrdata_fifo_mask,
	dqs_enable,
	dqs_reset,
	clk100_rising_edge,
	pattern_write_state,
	wrdata_2d,
	wrdata_3d,
	wrmask_2d,
	wrmask_3d,
	dq_oserdes_t_2d,
	dqs_oserdes_d_1d,
	dqs_oserdes_t_1d,
	dqsn_oserdes_d_1d,
	dqsn_oserdes_t_1d
);
	`include "./ddr2_cont_parameters.vh"
	
	input wire reset;
	input wire clk, clk90, clkx, clk270;
	input wire [INTERFACE_DATA_WIDTH-1 : 0] wrdata_fifo_data;
	input wire [INTERFACE_MASK_WIDTH-1 : 0] wrdata_fifo_mask;
	input wire dqs_enable;
	input wire dqs_reset;
	input wire clk100_rising_edge;
	input wire pattern_write_state;
	output reg [INTERFACE_DATA_WIDTH-1 : 0] wrdata_2d;
	output reg [INTERFACE_DATA_WIDTH-1 : 0] wrdata_3d;
	output reg [INTERFACE_MASK_WIDTH-1 : 0] wrmask_2d;
	output reg [INTERFACE_MASK_WIDTH-1 : 0] wrmask_3d;
	output reg [4*DDR2_DATA_WIDTH-1 : 0] dq_oserdes_t_2d;
	output reg [4*DDR2_DQS_DM_WIDTH-1 : 0] dqs_oserdes_d_1d;
	output reg [4*DDR2_DQS_DM_WIDTH-1 : 0] dqs_oserdes_t_1d;
	output reg [4*DDR2_DQS_DM_WIDTH-1 : 0] dqsn_oserdes_d_1d;
	output reg [4*DDR2_DQS_DM_WIDTH-1 : 0] dqsn_oserdes_t_1d;
	
	reg [INTERFACE_MASK_WIDTH-1 : 0] wrmask_1d;
	reg dqs_enable_1d;
	reg [3:0] dq_oserdes_t, dq_oserdes_t_1d;
	(* max_fanout="1" *) reg [3:0] dqs_oserdes_d, dqs_oserdes_t;
	(* max_fanout="1" *) reg [3:0] dqsn_oserdes_d, dqsn_oserdes_t;
	reg [INTERFACE_DATA_WIDTH-1 : 0] wrdata_1d;
	
	always @ (posedge clk) begin
		if (reset==1'b1) begin
			wrdata_1d <= 0;
			wrdata_2d <= 0;
			wrdata_3d <= 0;
		end else begin
			if (pattern_write_state) begin // ɒ^p^[ŁAIDELAY̒lT
				wrdata_1d <= {INITIAL_PATTERN_1, INITIAL_PATTERN_2};
			end else begin	
				wrdata_1d <= wrdata_fifo_data;
			end
			wrdata_2d <= wrdata_1d;
			wrdata_3d <= wrdata_2d;
		end
	end
	always @ (posedge clk) begin
		if (reset==1'b1) begin
			wrmask_1d <= 0;
			wrmask_2d <= 0;
			wrmask_3d <= 0;
		end else begin
			if (pattern_write_state) begin // ɒ^p^[ŁAIDELAY̒lT
				wrmask_1d <= 0;
			end else begin	
				wrmask_1d <= wrdata_fifo_mask;
			end
			wrmask_2d <= wrmask_1d;
			wrmask_3d <= wrmask_2d;
		end
	end
	
	// DQOSERDEST1~4ɓBdq_oserses_tOSERDEST1T4͂ɓMBOSERDES100MHzœ삷̂ŁA100MHz̃NbNオMandƂ
	always @(posedge clk) begin : DQ_OSERDES_LOOP
		integer k;
		// dq_oserdes_t_1dɂȂ1NbNxĂ܂
		if (reset) begin
			dq_oserdes_t <= -1;
			dq_oserdes_t_1d <= -1;
			dq_oserdes_t_2d <= -1;
		end else begin
			if (clk100_rising_edge) begin
				// if (dqs_reset)
					// dq_oserdes_t <= 4'b0011; // 딼̂݃AT[g
				// else
				dq_oserdes_t <= {4{~dqs_enable}};
			end
			
			dq_oserdes_t_1d <= dq_oserdes_t;
			
			for (k=0; k<=DDR2_DATA_WIDTH-1; k=k+1) begin
				dq_oserdes_t_2d[k*4 +: 4] <= dq_oserdes_t_1d;
			end
		end
	end
		
	// DQSOSERDESD1`D4T1`T4
	always @(posedge clk) begin
		if (reset)
			dqs_enable_1d <= 1'b0;
		else
			dqs_enable_1d <= dqs_enable;
	end
	always @* begin
		if (dqs_reset) begin // Write̍ŏȂ̂ŁADQSXX00
			dqs_oserdes_d <= 4'b00XX; // LSBMSBփVAo
			dqs_oserdes_t <= 4'b0011;
		end else if(dqs_enable_1d) begin // f[^o͂Ă鎞
			dqs_oserdes_d <= 4'b0101;
			dqs_oserdes_t <= 4'b0000;
		end else begin
			dqs_oserdes_d <= 4'bXXXX;
			dqs_oserdes_t <= 4'b1111;
		end
	end
	// always @(posedge clk) begin : DQS_OSERDES_1D // dqs_oserdes_d_1ddqs_oserdes_t_1dOSERDESɓ͂
		// integer k, m;
		
		// for(k=0; k<=DDR2_DQS_DM_WIDTH-1; k=k+1) begin // 8bit1CX^VG[V
			// for(m=0; m<4; m=m+1) begin
				// if (reset) begin
					// dqs_oserdes_d_1d[k*4+m] <= 1'bX;
					// dqs_oserdes_t_1d[k*4+m] <= 1'b1;
				// end else begin
					// dqs_oserdes_d_1d[k*4+m] <= dqs_oserdes_d[m];
					// dqs_oserdes_t_1d[k*4+m] <= dqs_oserdes_t[m];
				// end
			// end
		// end
		// for(k=0; k<=DDR2_DQS_DM_WIDTH-1; k=k+1) begin // 8bit1CX^VG[V
			// if (reset) begin
				// dqs_oserdes_d_1d[k*4 +: 4] <= 4'bXXXX;
				// dqs_oserdes_t_1d[k*4 +: 4] <= 4'b1111;
			// end else begin
				// dqs_oserdes_d_1d[k*4 +: 4] <= dqs_oserdes_d;
				// dqs_oserdes_t_1d[k*4 +: 4] <= dqs_oserdes_t;
			// end
		// end 
	// end
	
	generate
	genvar k, m;
		for(k=0; k<=DDR2_DQS_DM_WIDTH-1; k=k+1) begin : OSERDES_NO // 8bit1CX^VG[V
			for(m=0; m<4; m=m+1) begin : OSERDES_PIN_NO
				always @(posedge clk) begin
					if (reset) begin
						dqs_oserdes_d_1d[k*4+m] <= 1'bX;
						dqs_oserdes_t_1d[k*4+m] <= 1'b1;
					end else begin
						dqs_oserdes_d_1d[k*4+m] <= dqs_oserdes_d[m];
						dqs_oserdes_t_1d[k*4+m] <= dqs_oserdes_t[m];
					end
				end
			end
		end
	endgenerate
	
	always @* begin
		if (dqs_reset) begin // Write̍ŏȂ̂ŁADQSXX00
			dqsn_oserdes_d <= 4'b11XX; // LSBMSBփVAo
			dqsn_oserdes_t <= 4'b0011;
		end else if(dqs_enable_1d) begin // f[^o͂Ă鎞
			dqsn_oserdes_d <= 4'b1010;
			dqsn_oserdes_t <= 4'b0000;
		end else begin
			dqsn_oserdes_d <= 4'bXXXX;
			dqsn_oserdes_t <= 4'b1111;
		end
	end

	always @(posedge clk) begin : DQSN_OSERDES_1D // dqs_oserdes_d_1ddqs_oserdes_t_1dOSERDESɓ͂
		integer k;
		
		for(k=0; k<=DDR2_DQS_DM_WIDTH-1; k=k+1) begin // 8bit1CX^VG[V
			if (reset) begin
				dqsn_oserdes_d_1d[k*4 +: 4] <= 4'bXXXX;
				dqsn_oserdes_t_1d[k*4 +: 4] <= 4'b1111;
			end else begin
				dqsn_oserdes_d_1d[k*4 +: 4] <= dqsn_oserdes_d;
				dqsn_oserdes_t_1d[k*4 +: 4] <= dqsn_oserdes_t;
			end
		end 
	end

endmodule

